/* Actions (message types) */
mtype = { nop, a18, a33, a26, a3, a21, a20, a39, a41, a4, a29, a28, a44, a2, a10, a42, a13, a24, a11, a8, a12, a22, a9, a16, a40, a47, a34, a27, a23, a37, a30, a19, a38, a58, a17, a1, a57, a32, a48, a31, a14, a36, a7, a50, a35, a15, a52, a46, a5, a56, a49, a53, a54, a45, a55, a25, a6, a51, a43 };

/* Inter-process channels */
chan p5_4 = [0] of {mtype};
chan p8_5 = [0] of {mtype};
chan p5_3 = [0] of {mtype};
chan p9_3 = [0] of {mtype};
chan p7_1 = [0] of {mtype};
chan p2_1 = [0] of {mtype};
chan p3_1 = [0] of {mtype};
chan p4_0 = [0] of {mtype};
chan p6_0 = [0] of {mtype};

/* Environement<->process channels */
chan p7 = [0] of {mtype};
chan p5 = [0] of {mtype};
chan p4 = [0] of {mtype};
chan p0 = [0] of {mtype};
chan p9 = [0] of {mtype};
chan p8 = [0] of {mtype};
chan p6 = [0] of {mtype};
chan p3 = [0] of {mtype};
chan p2 = [0] of {mtype};
chan p1 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p7 ! a18
  :: p5 ! a33
  :: p4 ! a26
  :: p4 ! a3
  :: p4 ! a21
  :: p4 ! a20
  :: p4 ! a39
  :: p4 ! a41
  :: p4 ! a4
  :: p4 ! a29
  :: p4 ! a28
  :: p4 ! a44
  :: p4 ! a10
  :: p4 ! a42
  :: p4 ! a24
  :: p4 ! a11
  :: p4 ! a8
  :: p4 ! a12
  :: p4 ! a22
  :: p4 ! a9
  :: p7 ! a16
  :: p4 ! a40
  :: p4 ! a47
  :: p4 ! a27
  :: p4 ! a23
  :: p7 ! a19
  :: p7 ! a17
  :: p4 ! a1
  :: p4 ! a48
  :: p4 ! a14
  :: p4 ! a7
  :: p7 ! a15
  :: p0 ! a52
  :: p4 ! a5
  :: p4 ! a25
  :: p0 ! a51
  :: p9 ! nop
  :: p8 ! nop
  :: p7 ! nop
  :: p6 ! nop
  :: p5 ! nop
  :: p4 ! nop
  :: p3 ! nop
  :: p2 ! nop
  :: p1 ! nop
  :: p0 ! nop
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 19;
  do
  :: state == 19 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 3;
      fi
    }
  :: state == 3 ->
    atomic {
      if
      :: p4_0 ? a6 ->
        act ! a6;
        state = 10;
      :: p4_0 ? a46 ->
        act ! a46;
        state = 7;
      fi
    }
  :: state == 10 ->
    atomic {
      if
      :: p0 ? a51 ->
        act ! a51;
        state = 12;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p0 ? a51 ->
        act ! a51;
        state = 2;
      fi
    }
  :: state == 12 ->
    atomic {
      if
      :: p0 ? a52 ->
        act ! a52;
        state = 13;
      fi
    }
  :: state == 2 ->
    atomic {
      if
      :: p0 ? a52 ->
        act ! a52;
        state = 16;
      fi
    }
  :: state == 13 ->
    atomic {
      if
      :: p6_0 ? a53 ->
        act ! a53;
        state = 8;
      fi
    }
  :: state == 16 ->
    atomic {
      if
      :: p6_0 ? a53 ->
        act ! a53;
        state = 5;
      fi
    }
  :: state == 8 ->
    atomic {
      if
      :: p6_0 ? a54 ->
        act ! a54;
        state = 6;
      fi
    }
  :: state == 5 ->
    atomic {
      if
      :: p6_0 ? a54 ->
        act ! a54;
        state = 17;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p6_0 ? a55 ->
        act ! a55;
        state = 3;
      fi
    }
  :: state == 17 ->
    atomic {
      if
      :: p6_0 ? a55 ->
        act ! a55;
        state = 15;
      fi
    }
  :: state == 15 ->
    atomic {
      if
      :: p4_0 ? a46 ->
        act ! a46;
        state = 9;
      :: p4_0 ? a45 ->
        act ! a45;
        state = 10;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p0 ? a51 ->
        act ! a51;
        state = 11;
      fi
    }
  :: state == 11 ->
    atomic {
      if
      :: p0 ? a52 ->
        act ! a52;
        state = 18;
      fi
    }
  :: state == 18 ->
    atomic {
      if
      :: p6_0 ? a53 ->
        act ! a53;
        state = 14;
      fi
    }
  :: state == 14 ->
    atomic {
      if
      :: p6_0 ? a54 ->
        act ! a54;
        state = 1;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p6_0 ? a55 ->
        act ! a55;
        state = 4;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p4_0 ? a6 ->
        act ! a6;
        state = 9;
      :: p4_0 ? a45 ->
        act ! a45;
        state = 9;
      :: p4_0 ? a46 ->
        act ! a46;
        state = 9;
      fi
    }
  od
}

/* Process 1 */
active proctype Proc1()
{
  int state = 52;
  do
  :: state == 52 ->
    atomic {
      if
      :: p1 ? nop ->

        state = 37;
      fi
    }
  :: state == 37 ->
    atomic {
      if
      :: p3_1 ? a35 ->
        act ! a35;
        state = 40;
      :: p3_1 ? a36 ->
        act ! a36;
        state = 49;
      fi
    }
  :: state == 40 ->
    atomic {
      if
      :: p2_1 ? a56 ->
        act ! a56;
        state = 47;
      fi
    }
  :: state == 49 ->
    atomic {
      if
      :: p2_1 ? a56 ->
        act ! a56;
        state = 35;
      fi
    }
  :: state == 47 ->
    atomic {
      if
      :: p2_1 ? a57 ->
        act ! a57;
        state = 44;
      fi
    }
  :: state == 35 ->
    atomic {
      if
      :: p2_1 ? a57 ->
        act ! a57;
        state = 28;
      fi
    }
  :: state == 44 ->
    atomic {
      if
      :: p7_1 ? a58 ->
        act ! a58;
        state = 25;
      fi
    }
  :: state == 28 ->
    atomic {
      if
      :: p7_1 ? a58 ->
        act ! a58;
        state = 20;
      fi
    }
  :: state == 25 ->
    atomic {
      if
      :: p2_1 ? a49 ->
        act ! a49;
        state = 32;
      fi
    }
  :: state == 20 ->
    atomic {
      if
      :: p2_1 ? a49 ->
        act ! a49;
        state = 21;
      fi
    }
  :: state == 32 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 27;
      fi
    }
  :: state == 21 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 43;
      fi
    }
  :: state == 27 ->
    atomic {
      if
      :: p3_1 ? a35 ->
        act ! a35;
        state = 49;
      :: p3_1 ? a36 ->
        act ! a36;
        state = 36;
      fi
    }
  :: state == 43 ->
    atomic {
      if
      :: p3_1 ? a35 ->
        act ! a35;
        state = 49;
      :: p3_1 ? a36 ->
        act ! a36;
        state = 49;
      fi
    }
  :: state == 36 ->
    atomic {
      if
      :: p2_1 ? a56 ->
        act ! a56;
        state = 33;
      fi
    }
  :: state == 33 ->
    atomic {
      if
      :: p2_1 ? a57 ->
        act ! a57;
        state = 38;
      fi
    }
  :: state == 38 ->
    atomic {
      if
      :: p7_1 ? a58 ->
        act ! a58;
        state = 34;
      fi
    }
  :: state == 34 ->
    atomic {
      if
      :: p2_1 ? a49 ->
        act ! a49;
        state = 39;
      fi
    }
  :: state == 39 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 23;
      fi
    }
  :: state == 23 ->
    atomic {
      if
      :: p3_1 ? a36 ->
        act ! a36;
        state = 49;
      :: p3_1 ? a35 ->
        act ! a35;
        state = 30;
      fi
    }
  :: state == 30 ->
    atomic {
      if
      :: p2_1 ? a56 ->
        act ! a56;
        state = 22;
      fi
    }
  :: state == 22 ->
    atomic {
      if
      :: p2_1 ? a57 ->
        act ! a57;
        state = 42;
      fi
    }
  :: state == 42 ->
    atomic {
      if
      :: p7_1 ? a58 ->
        act ! a58;
        state = 24;
      fi
    }
  :: state == 24 ->
    atomic {
      if
      :: p2_1 ? a49 ->
        act ! a49;
        state = 45;
      fi
    }
  :: state == 45 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 48;
      fi
    }
  :: state == 48 ->
    atomic {
      if
      :: p3_1 ? a36 ->
        act ! a36;
        state = 50;
      fi
    }
  :: state == 50 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 41;
      :: p2_1 ? a56 ->
        act ! a56;
        state = 51;
      fi
    }
  :: state == 41 ->
    atomic {
      if
      :: p3_1 ? a35 ->
        act ! a35;
        state = 41;
      :: p2_1 ? a56 ->
        act ! a56;
        state = 41;
      :: p2_1 ? a49 ->
        act ! a49;
        state = 41;
      :: p7_1 ? a58 ->
        act ! a58;
        state = 41;
      fi
    }
  :: state == 51 ->
    atomic {
      if
      :: p2_1 ? a57 ->
        act ! a57;
        state = 31;
      fi
    }
  :: state == 31 ->
    atomic {
      if
      :: p7_1 ? a58 ->
        act ! a58;
        state = 46;
      fi
    }
  :: state == 46 ->
    atomic {
      if
      :: p2_1 ? a49 ->
        act ! a49;
        state = 26;
      fi
    }
  :: state == 26 ->
    atomic {
      if
      :: p7_1 ? a50 ->
        act ! a50;
        state = 29;
      fi
    }
  :: state == 29 ->
    atomic {
      if
      :: p3_1 ? a35 ->
        act ! a35;
        state = 40;
      fi
    }
  od
}

/* Process 2 */
active proctype Proc2()
{
  int state = 66;
  do
  :: state == 66 ->
    atomic {
      if
      :: p2 ? nop ->

        state = 54;
      fi
    }
  :: state == 54 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 64;
      :: p2_1 ! a49 ->

        state = 57;
      :: p2_1 ! a57 ->

        state = 57;
      fi
    }
  :: state == 64 ->
    atomic {
      if
      :: p2_1 ! a57 ->

        state = 55;
      :: p2_1 ! a56 ->

        state = 57;
      fi
    }
  :: state == 57 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 57;
      :: p2_1 ! a49 ->

        state = 57;
      :: p2_1 ! a57 ->

        state = 57;
      fi
    }
  :: state == 55 ->
    atomic {
      if
      :: p2_1 ! a49 ->

        state = 62;
      :: p2_1 ! a57 ->

        state = 57;
      fi
    }
  :: state == 62 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 61;
      :: p2_1 ! a49 ->

        state = 57;
      fi
    }
  :: state == 61 ->
    atomic {
      if
      :: p2_1 ! a57 ->

        state = 60;
      :: p2_1 ! a49 ->

        state = 57;
      fi
    }
  :: state == 60 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 57;
      :: p2_1 ! a49 ->

        state = 59;
      fi
    }
  :: state == 59 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 63;
      :: p2_1 ! a49 ->

        state = 57;
      fi
    }
  :: state == 63 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 57;
      :: p2_1 ! a49 ->

        state = 57;
      :: p2_1 ! a57 ->

        state = 53;
      fi
    }
  :: state == 53 ->
    atomic {
      if
      :: p2_1 ! a56 ->

        state = 57;
      :: p2_1 ! a49 ->

        state = 58;
      fi
    }
  :: state == 58 ->
    atomic {
      if
      :: p2_1 ! a57 ->

        state = 57;
      :: p2_1 ! a56 ->

        state = 65;
      fi
    }
  :: state == 65 ->
    atomic {
      if
      :: p2_1 ! a57 ->

        state = 56;
      :: p2_1 ! a56 ->

        state = 57;
      fi
    }
  :: state == 56 ->
    atomic {
      if
      :: p2_1 ! a57 ->

        state = 57;
      :: p2_1 ! a49 ->

        state = 54;
      fi
    }
  od
}

/* Process 3 */
active proctype Proc3()
{
  int state = 82;
  do
  :: state == 82 ->
    atomic {
      if
      :: p3 ? nop ->

        state = 71;
      fi
    }
  :: state == 71 ->
    atomic {
      if
      :: p5_3 ? a32 ->
        act ! a32;
        state = 79;
      fi
    }
  :: state == 79 ->
    atomic {
      if
      :: p3_1 ! a35 ->

        state = 69;
      fi
    }
  :: state == 69 ->
    atomic {
      if
      :: p3_1 ! a36 ->

        state = 72;
      fi
    }
  :: state == 72 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 73;
      fi
    }
  :: state == 73 ->
    atomic {
      if
      :: p9_3 ? a31 ->
        act ! a31;
        state = 76;
      fi
    }
  :: state == 76 ->
    atomic {
      if
      :: p5_3 ? a32 ->
        act ! a32;
        state = 80;
      :: p5_3 ? a37 ->
        act ! a37;
        state = 68;
      fi
    }
  :: state == 80 ->
    atomic {
      if
      :: p3_1 ! a35 ->

        state = 75;
      fi
    }
  :: state == 68 ->
    atomic {
      if
      :: p3_1 ! a35 ->

        state = 70;
      fi
    }
  :: state == 75 ->
    atomic {
      if
      :: p3_1 ! a36 ->

        state = 77;
      fi
    }
  :: state == 70 ->
    atomic {
      if
      :: p3_1 ! a36 ->

        state = 78;
      fi
    }
  :: state == 77 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 74;
      fi
    }
  :: state == 78 ->
    atomic {
      if
      :: p9_3 ? a30 ->
        act ! a30;
        state = 81;
      fi
    }
  :: state == 74 ->
    atomic {
      if
      :: p9_3 ? a31 ->
        act ! a31;
        state = 67;
      fi
    }
  :: state == 81 ->
    atomic {
      if
      :: p9_3 ? a31 ->
        act ! a31;
        state = 71;
      fi
    }
  :: state == 67 ->
    atomic {
      if
      :: p5_3 ? a37 ->
        act ! a37;
        state = 80;
      fi
    }
  od
}

/* Process 4 */
active proctype Proc4()
{
  int state = 107;
  do
  :: state == 107 ->
    atomic {
      if
      :: p4 ? nop ->

        state = 88;
      fi
    }
  :: state == 88 ->
    atomic {
      if
      :: p4 ? a7 ->
        act ! a7;
        state = 87;
      fi
    }
  :: state == 87 ->
    atomic {
      if
      :: p4 ? a40 ->
        act ! a40;
        state = 85;
      :: p4 ? a9 ->
        act ! a9;
        state = 91;
      :: p4 ? a12 ->
        act ! a12;
        state = 86;
      :: p4 ? a8 ->
        act ! a8;
        state = 87;
      :: p4 ? a42 ->
        act ! a42;
        state = 85;
      :: p4 ? a3 ->
        act ! a3;
        state = 92;
      fi
    }
  :: state == 85 ->
    atomic {
      if
      :: p4 ? a41 ->
        act ! a41;
        state = 89;
      :: p4 ? a39 ->
        act ! a39;
        state = 84;
      fi
    }
  :: state == 91 ->
    atomic {
      if
      :: p4 ? a10 ->
        act ! a10;
        state = 83;
      fi
    }
  :: state == 86 ->
    atomic {
      if
      :: p4 ? a5 ->
        act ! a5;
        state = 87;
      :: p4 ? a11 ->
        act ! a11;
        state = 90;
      fi
    }
  :: state == 92 ->
    atomic {
      if
      :: p4 ? a4 ->
        act ! a4;
        state = 86;
      fi
    }
  :: state == 89 ->
    atomic {
      if
      :: p5_4 ? a13 ->
        act ! a13;
        state = 94;
      :: p5_4 ? a43 ->
        act ! a43;
        state = 87;
      :: p4_0 ! a46 ->

        state = 93;
      fi
    }
  :: state == 84 ->
    atomic {
      if
      :: p4 ? a44 ->
        act ! a44;
        state = 89;
      fi
    }
  :: state == 83 ->
    atomic {
      if
      :: p4 ? a1 ->
        act ! a1;
        state = 98;
      fi
    }
  :: state == 90 ->
    atomic {
      if
      :: p5_4 ? a2 ->
        act ! a2;
        state = 95;
      fi
    }
  :: state == 94 ->
    atomic {
      if
      :: p4 ? a27 ->
        act ! a27;
        state = 94;
      :: p4 ? a1 ->
        act ! a1;
        state = 94;
      :: p5_4 ? a13 ->
        act ! a13;
        state = 94;
      :: p5_4 ? a43 ->
        act ! a43;
        state = 94;
      :: p4 ? a29 ->
        act ! a29;
        state = 94;
      :: p4 ? a4 ->
        act ! a4;
        state = 94;
      :: p4 ? a22 ->
        act ! a22;
        state = 94;
      :: p4_0 ! a46 ->

        state = 94;
      :: p4 ? a14 ->
        act ! a14;
        state = 94;
      :: p4 ? a25 ->
        act ! a25;
        state = 94;
      :: p4 ? a42 ->
        act ! a42;
        state = 94;
      :: p4 ? a21 ->
        act ! a21;
        state = 94;
      :: p5_4 ? a2 ->
        act ! a2;
        state = 94;
      fi
    }
  :: state == 93 ->
    atomic {
      if
      :: p4_0 ! a45 ->

        state = 96;
      fi
    }
  :: state == 98 ->
    atomic {
      if
      :: p4_0 ! a6 ->

        state = 88;
      fi
    }
  :: state == 95 ->
    atomic {
      if
      :: p4 ? a14 ->
        act ! a14;
        state = 97;
      fi
    }
  :: state == 96 ->
    atomic {
      if
      :: p4 ? a48 ->
        act ! a48;
        state = 99;
      :: p4 ? a25 ->
        act ! a25;
        state = 100;
      :: p4 ? a20 ->
        act ! a20;
        state = 101;
      fi
    }
  :: state == 97 ->
    atomic {
      if
      :: p5_4 ? a13 ->
        act ! a13;
        state = 87;
      fi
    }
  :: state == 99 ->
    atomic {
      if
      :: p4 ? a47 ->
        act ! a47;
        state = 87;
      :: p4 ? a29 ->
        act ! a29;
        state = 102;
      fi
    }
  :: state == 100 ->
    atomic {
      if
      :: p4 ? a24 ->
        act ! a24;
        state = 104;
      fi
    }
  :: state == 101 ->
    atomic {
      if
      :: p4 ? a23 ->
        act ! a23;
        state = 105;
      fi
    }
  :: state == 102 ->
    atomic {
      if
      :: p4 ? a28 ->
        act ! a28;
        state = 103;
      fi
    }
  :: state == 104 ->
    atomic {
      if
      :: p4 ? a21 ->
        act ! a21;
        state = 96;
      fi
    }
  :: state == 105 ->
    atomic {
      if
      :: p4 ? a22 ->
        act ! a22;
        state = 96;
      fi
    }
  :: state == 103 ->
    atomic {
      if
      :: p4 ? a27 ->
        act ! a27;
        state = 106;
      fi
    }
  :: state == 106 ->
    atomic {
      if
      :: p4 ? a26 ->
        act ! a26;
        state = 99;
      fi
    }
  od
}

/* Process 5 */
active proctype Proc5()
{
  int state = 128;
  do
  :: state == 128 ->
    atomic {
      if
      :: p5 ? nop ->

        state = 110;
      fi
    }
  :: state == 110 ->
    atomic {
      if
      :: p5_4 ! a43 ->

        state = 126;
      :: p5_4 ! a2 ->

        state = 112;
      :: p5_3 ! a37 ->

        state = 125;
      fi
    }
  :: state == 126 ->
    atomic {
      if
      :: p8_5 ? a34 ->
        act ! a34;
        state = 111;
      fi
    }
  :: state == 112 ->
    atomic {
      if
      :: p8_5 ? a34 ->
        act ! a34;
        state = 109;
      :: p8_5 ? a38 ->
        act ! a38;
        state = 114;
      fi
    }
  :: state == 125 ->
    atomic {
      if
      :: p5_4 ! a2 ->

        state = 125;
      :: p5 ? a33 ->
        act ! a33;
        state = 125;
      :: p5_4 ! a13 ->

        state = 125;
      :: p8_5 ? a34 ->
        act ! a34;
        state = 125;
      :: p5_3 ! a37 ->

        state = 125;
      :: p5_3 ! a32 ->

        state = 125;
      :: p8_5 ? a38 ->
        act ! a38;
        state = 125;
      fi
    }
  :: state == 111 ->
    atomic {
      if
      :: p5_3 ! a32 ->

        state = 115;
      fi
    }
  :: state == 109 ->
    atomic {
      if
      :: p5_3 ! a32 ->

        state = 118;
      fi
    }
  :: state == 114 ->
    atomic {
      if
      :: p5_4 ! a2 ->

        state = 114;
      :: p5_3 ! a32 ->

        state = 114;
      :: p8_5 ? a38 ->
        act ! a38;
        state = 114;
      :: p5_4 ! a43 ->

        state = 114;
      :: p5 ? a33 ->
        act ! a33;
        state = 114;
      fi
    }
  :: state == 115 ->
    atomic {
      if
      :: p5 ? a33 ->
        act ! a33;
        state = 116;
      fi
    }
  :: state == 118 ->
    atomic {
      if
      :: p5 ? a33 ->
        act ! a33;
        state = 108;
      fi
    }
  :: state == 116 ->
    atomic {
      if
      :: p5_3 ! a37 ->

        state = 120;
      fi
    }
  :: state == 108 ->
    atomic {
      if
      :: p5_3 ! a37 ->

        state = 117;
      fi
    }
  :: state == 120 ->
    atomic {
      if
      :: p8_5 ? a38 ->
        act ! a38;
        state = 110;
      fi
    }
  :: state == 117 ->
    atomic {
      if
      :: p8_5 ? a38 ->
        act ! a38;
        state = 127;
      fi
    }
  :: state == 127 ->
    atomic {
      if
      :: p5_4 ! a2 ->

        state = 124;
      :: p5_4 ! a13 ->

        state = 126;
      fi
    }
  :: state == 124 ->
    atomic {
      if
      :: p8_5 ? a34 ->
        act ! a34;
        state = 122;
      fi
    }
  :: state == 122 ->
    atomic {
      if
      :: p5_3 ! a32 ->

        state = 119;
      fi
    }
  :: state == 119 ->
    atomic {
      if
      :: p5 ? a33 ->
        act ! a33;
        state = 123;
      fi
    }
  :: state == 123 ->
    atomic {
      if
      :: p5_3 ! a37 ->

        state = 121;
      fi
    }
  :: state == 121 ->
    atomic {
      if
      :: p8_5 ? a38 ->
        act ! a38;
        state = 113;
      fi
    }
  :: state == 113 ->
    atomic {
      if
      :: p5_4 ! a13 ->

        state = 124;
      :: p5_4 ! a2 ->

        state = 124;
      fi
    }
  od
}

/* Process 6 */
active proctype Proc6()
{
  int state = 133;
  do
  :: state == 133 ->
    atomic {
      if
      :: p6 ? nop ->

        state = 132;
      fi
    }
  :: state == 132 ->
    atomic {
      if
      :: p6_0 ! a55 ->

        state = 130;
      :: p6_0 ! a53 ->

        state = 131;
      fi
    }
  :: state == 130 ->
    atomic {
      if
      :: p6_0 ! a54 ->

        state = 130;
      fi
    }
  :: state == 131 ->
    atomic {
      if
      :: p6_0 ! a54 ->

        state = 129;
      fi
    }
  :: state == 129 ->
    atomic {
      if
      :: p6_0 ! a54 ->

        state = 130;
      :: p6_0 ! a55 ->

        state = 132;
      fi
    }
  od
}

/* Process 7 */
active proctype Proc7()
{
  int state = 188;
  do
  :: state == 188 ->
    atomic {
      if
      :: p7 ? nop ->

        state = 142;
      fi
    }
  :: state == 142 ->
    atomic {
      if
      :: p7_1 ! a50 ->

        state = 141;
      :: p7_1 ! a58 ->

        state = 140;
      fi
    }
  :: state == 141 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 139;
      fi
    }
  :: state == 140 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 146;
      fi
    }
  :: state == 139 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 145;
      fi
    }
  :: state == 146 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 144;
      fi
    }
  :: state == 145 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 143;
      fi
    }
  :: state == 144 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 137;
      fi
    }
  :: state == 143 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 136;
      fi
    }
  :: state == 137 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 134;
      fi
    }
  :: state == 136 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 154;
      fi
    }
  :: state == 134 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 170;
      fi
    }
  :: state == 170 ->
    atomic {
      if
      :: p7_1 ! a50 ->

        state = 147;
      fi
    }
  :: state == 147 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 186;
      fi
    }
  :: state == 186 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 168;
      fi
    }
  :: state == 168 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 165;
      fi
    }
  :: state == 165 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 164;
      fi
    }
  :: state == 164 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 157;
      fi
    }
  :: state == 157 ->
    atomic {
      if
      :: p7_1 ! a50 ->

        state = 141;
      :: p7_1 ! a58 ->

        state = 156;
      fi
    }
  :: state == 156 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 176;
      fi
    }
  :: state == 176 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 177;
      fi
    }
  :: state == 177 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 135;
      fi
    }
  :: state == 135 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 138;
      fi
    }
  :: state == 138 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 180;
      fi
    }
  :: state == 180 ->
    atomic {
      if
      :: p7_1 ! a50 ->

        state = 171;
      fi
    }
  :: state == 171 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 178;
      fi
    }
  :: state == 178 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 187;
      fi
    }
  :: state == 187 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 182;
      fi
    }
  :: state == 182 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 183;
      fi
    }
  :: state == 183 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 167;
      fi
    }
  :: state == 167 ->
    atomic {
      if
      :: p7_1 ! a58 ->

        state = 161;
      fi
    }
  :: state == 161 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 169;
      fi
    }
  :: state == 169 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 166;
      fi
    }
  :: state == 166 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 173;
      fi
    }
  :: state == 173 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 160;
      fi
    }
  :: state == 160 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 163;
      fi
    }
  :: state == 163 ->
    atomic {
      if
      :: p7_1 ! a58 ->

        state = 141;
      :: p7_1 ! a50 ->

        state = 162;
      fi
    }
  :: state == 162 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 159;
      fi
    }
  :: state == 159 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 158;
      fi
    }
  :: state == 158 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 153;
      fi
    }
  :: state == 153 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 155;
      fi
    }
  :: state == 155 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 172;
      fi
    }
  :: state == 172 ->
    atomic {
      if
      :: p7_1 ! a58 ->

        state = 181;
      fi
    }
  :: state == 181 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 174;
      fi
    }
  :: state == 174 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 175;
      fi
    }
  :: state == 175 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 179;
      fi
    }
  :: state == 179 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 148;
      fi
    }
  :: state == 148 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 184;
      fi
    }
  :: state == 184 ->
    atomic {
      if
      :: p7_1 ! a50 ->

        state = 185;
      :: p7_1 ! a58 ->

        state = 141;
      fi
    }
  :: state == 185 ->
    atomic {
      if
      :: p7 ? a17 ->
        act ! a17;
        state = 152;
      fi
    }
  :: state == 152 ->
    atomic {
      if
      :: p7 ? a16 ->
        act ! a16;
        state = 151;
      fi
    }
  :: state == 151 ->
    atomic {
      if
      :: p7 ? a19 ->
        act ! a19;
        state = 150;
      fi
    }
  :: state == 150 ->
    atomic {
      if
      :: p7 ? a18 ->
        act ! a18;
        state = 149;
      fi
    }
  :: state == 149 ->
    atomic {
      if
      :: p7 ? a15 ->
        act ! a15;
        state = 142;
      fi
    }
  od
}

/* Process 8 */
active proctype Proc8()
{
  int state = 191;
  do
  :: state == 191 ->
    atomic {
      if
      :: p8 ? nop ->

        state = 190;
      fi
    }
  :: state == 190 ->
    atomic {
      if
      :: p8_5 ! a34 ->

        state = 189;
      fi
    }
  :: state == 189 ->
    atomic {
      if
      :: p8_5 ! a38 ->

        state = 190;
      fi
    }
  od
}

/* Process 9 */
active proctype Proc9()
{
  int state = 197;
  do
  :: state == 197 ->
    atomic {
      if
      :: p9 ? nop ->

        state = 195;
      fi
    }
  :: state == 195 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 194;
      fi
    }
  :: state == 194 ->
    atomic {
      if
      :: p9_3 ! a31 ->

        state = 192;
      :: p9_3 ! a30 ->

        state = 193;
      fi
    }
  :: state == 192 ->
    atomic {
      if
      :: p9_3 ! a30 ->

        state = 196;
      fi
    }
  :: state == 193 ->
    atomic {
      if
      :: p9_3 ! a31 ->

        state = 193;
      fi
    }
  :: state == 196 ->
    atomic {
      if
      :: p9_3 ! a31 ->

        state = 195;
      :: p9_3 ! a30 ->

        state = 193;
      fi
    }
  od
}

#define p_a18	 (lastAction == a18)
#define p_a33	 (lastAction == a33)
#define p_a26	 (lastAction == a26)
#define p_a3	 (lastAction == a3)
#define p_a21	 (lastAction == a21)
#define p_a20	 (lastAction == a20)
#define p_a39	 (lastAction == a39)
#define p_a41	 (lastAction == a41)
#define p_a4	 (lastAction == a4)
#define p_a29	 (lastAction == a29)
#define p_a28	 (lastAction == a28)
#define p_a44	 (lastAction == a44)
#define p_a2	 (lastAction == a2)
#define p_a10	 (lastAction == a10)
#define p_a42	 (lastAction == a42)
#define p_a13	 (lastAction == a13)
#define p_a24	 (lastAction == a24)
#define p_a11	 (lastAction == a11)
#define p_a8	 (lastAction == a8)
#define p_a12	 (lastAction == a12)
#define p_a22	 (lastAction == a22)
#define p_a9	 (lastAction == a9)
#define p_a16	 (lastAction == a16)
#define p_a40	 (lastAction == a40)
#define p_a47	 (lastAction == a47)
#define p_a34	 (lastAction == a34)
#define p_a27	 (lastAction == a27)
#define p_a23	 (lastAction == a23)
#define p_a37	 (lastAction == a37)
#define p_a30	 (lastAction == a30)
#define p_a19	 (lastAction == a19)
#define p_a38	 (lastAction == a38)
#define p_a58	 (lastAction == a58)
#define p_a17	 (lastAction == a17)
#define p_a1	 (lastAction == a1)
#define p_a57	 (lastAction == a57)
#define p_a32	 (lastAction == a32)
#define p_a48	 (lastAction == a48)
#define p_a31	 (lastAction == a31)
#define p_a14	 (lastAction == a14)
#define p_a36	 (lastAction == a36)
#define p_a7	 (lastAction == a7)
#define p_a50	 (lastAction == a50)
#define p_a35	 (lastAction == a35)
#define p_a15	 (lastAction == a15)
#define p_a52	 (lastAction == a52)
#define p_a46	 (lastAction == a46)
#define p_a5	 (lastAction == a5)
#define p_a56	 (lastAction == a56)
#define p_a49	 (lastAction == a49)
#define p_a53	 (lastAction == a53)
#define p_a54	 (lastAction == a54)
#define p_a45	 (lastAction == a45)
#define p_a55	 (lastAction == a55)
#define p_a25	 (lastAction == a25)
#define p_a6	 (lastAction == a6)
#define p_a51	 (lastAction == a51)
#define p_a43	 (lastAction == a43)


ltl p1	{ (p_a2 || p_a20) V (p_a2 || p_a20 || !p_a23) }
ltl p2	{ (p_a23 || p_a41) V (p_a23 || !p_a40 || p_a41 || <>p_a6) }
ltl p3	{ (p_a25 || p_a48) V (!p_a24 || p_a25 || p_a48 || (!p_a11 U p_a23)) }
ltl p4	{ p_a25 V (!p_a6 || p_a25 || (p_a29 V (!p_a26 || p_a29))) }
ltl p5	{ []((!p_a22 || []!p_a27) && (!p_a2 || (p_a47 V (!p_a7 || p_a47)))) }
ltl p6	{ p_a13 V (p_a13 || !p_a47) }
ltl p7	{ (p_a20 || p_a48) V (!p_a10 || p_a20 || p_a48 || []!p_a39) }
ltl p8	{ [](!p_a29 && (!p_a7 || (p_a48 V (!p_a10 || p_a48)))) }
ltl p9	{ (p_a23 || p_a44) V (!p_a11 || p_a23 || p_a44 || <>p_a13) }
ltl p10	{ !p_a42 U (p_a13 || p_a43) }
ltl p11	{ p_a13 V (p_a13 || !p_a41) }
ltl p12	{ (p_a27 || p_a44) V (p_a27 || p_a44 || !(p_a1 || p_a8)) }
ltl p13	{ (p_a4 || p_a24) V (p_a4 || p_a24 || !(p_a1 || p_a10)) }
ltl p14	{ (p_a14 || p_a46) V (p_a14 || p_a46 || !p_a47) }
ltl p15	{ (p_a46 || p_a47) V (!p_a27 || p_a46 || p_a47 || <>p_a48) }
ltl p16	{ <>p_a13 }
ltl p17	{ (p_a13 || p_a41) V (p_a13 || p_a41 || !p_a45 || []!p_a24) }
ltl p18	{ p_a26 V (p_a26 || !p_a28 || <>p_a26) }
ltl p19	{ p_a44 V (!p_a40 || p_a44 || (!p_a23 U p_a8)) }
ltl p20	{ (!p_a29 || []!p_a2) U p_a13 }
